*** /dev/null
--- b/src/include/utils/sampleutils.h
***************
*** 0 ****
--- 1,49 ----
+ /*-------------------------------------------------------------------------
+  *
+  * sampleutils.h
+  *	  APIs for Tablesample Support, containing Vitter's Algo APIs, analyze.c
+  *	  is also using the APIs.
+  *
+  *
+  * Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
+  * Portions Copyright (c) 1994, Regents of the University of California
+  *
+  * src/include/utils/sampleutils.h
+  *
+  *-------------------------------------------------------------------------
+  */
+ #ifndef SAMPLEUTILS_H
+ #define SAMPLEUTILS_H
+ 
+ #include "storage/block.h"
+ #include "utils/relcache.h"
+ #include "access/htup.h"
+ #include "storage/buf.h"
+ 
+ /* Data structure for Algorithm S from Knuth 3.4.2 */
+ typedef struct
+ {
+ 	BlockNumber N;				/* number of blocks, known in advance */
+ 	int			n;				/* desired sample size */
+ 	BlockNumber t;				/* current block number */
+ 	int			m;				/* blocks selected so far */
+ } BlockSamplerData;
+ 
+ typedef BlockSamplerData *BlockSampler;
+ 
+ 
+ extern void BlockSampler_Init(BlockSampler bs, BlockNumber nblocks,
+ 				  int samplesize);
+ extern bool BlockSampler_HasMore(BlockSampler bs);
+ extern BlockNumber BlockSampler_Next(void *state, BlockSampler bs);
+ extern double anl_init_selection_state(void *state, int n);
+ extern double anl_get_next_S(void *state, double t, int n, double *stateptr);
+ extern double anl_random_fract(void *state);
+ extern int get_rand_in_range(void *state, int a, int b);
+ extern void sample_set_seed(void *random_state, double seed);
+ extern double sample_random(void *random_state);
+ extern int acquire_vitter_rows(Relation onerel, void *state, HeapTuple *rows, int targrows,
+ 							BlockNumber totalblocks, BufferAccessStrategy vac_strategy,
+ 							double *totalrows, double *totaldeadrows, bool isanalyze, int elevel);
+ 
+ #endif /* SAMPLEUTILS_H */
*** a/src/test/regress/parallel_schedule
--- b/src/test/regress/parallel_schedule
***************
*** 59,65 **** test: create_index create_view
  # ----------
  # Another group of parallel tests
  # ----------
! test: create_aggregate create_function_3 create_cast constraints triggers inherit create_table_like typed_table vacuum drop_if_exists
  
  # ----------
  # sanity_check does a vacuum, affecting the sort order of SELECT *
--- 59,65 ----
  # ----------
  # Another group of parallel tests
  # ----------
! test: create_aggregate create_function_3 create_cast constraints triggers inherit create_table_like typed_table vacuum drop_if_exists tablesample
  
  # ----------
  # sanity_check does a vacuum, affecting the sort order of SELECT *
*** a/src/test/regress/serial_schedule
--- b/src/test/regress/serial_schedule
***************
*** 67,72 **** test: create_table_like
--- 67,73 ----
  test: typed_table
  test: vacuum
  test: drop_if_exists
+ test: tablesample
  test: sanity_check
  test: errors
  test: select
*** /dev/null
--- b/src/test/regress/sql/tablesample.sql
***************
*** 0 ****
--- 1,58 ----
+ --
+ -- TABLESAMPLE TEST
+ --
+ 
+ CREATE TABLE sample (id INT, name text);
+ 
+ INSERT INTO sample VALUES (1, 'victor');
+ INSERT INTO sample VALUES (2, 'peter');
+ INSERT INTO sample VALUES (3, 'james');
+ INSERT INTO sample VALUES (4, 'paul');
+ INSERT INTO sample VALUES (5, 'kate');
+ INSERT INTO sample VALUES (6, 'jane');
+ INSERT INTO sample VALUES (7, 'samual');
+ INSERT INTO sample VALUES (8, 'david');
+ INSERT INTO sample VALUES (9, 'job');
+ INSERT INTO sample VALUES (10, 'neil');
+ INSERT INTO sample VALUES (11, 'victor');
+ INSERT INTO sample VALUES (12, 'peter');
+ INSERT INTO sample VALUES (13, 'james');
+ INSERT INTO sample VALUES (14, 'paul');
+ INSERT INTO sample VALUES (15, 'kate');
+ INSERT INTO sample VALUES (16, 'jane');
+ INSERT INTO sample VALUES (17, 'samual');
+ INSERT INTO sample VALUES (18, 'david');
+ INSERT INTO sample VALUES (19, 'job');
+ INSERT INTO sample VALUES (20, 'neil');
+ 
+ ANALYZE sample;
+ 
+ SELECT * FROM sample TABLESAMPLE SYSTEM (60) REPEATABLE (10);
+ 
+ SELECT * FROM sample TABLESAMPLE BERNOULLI (70) REPEATABLE (11);
+ 
+ SELECT * FROM sample TABLESAMPLE BERNOULLI (70) REPEATABLE (11);
+ 
+ SELECT * FROM sample TABLESAMPLE BERNOULLI (70) REPEATABLE (19);
+ 
+ SELECT * FROM sample TABLESAMPLE BERNOULLI (7) REPEATABLE (19);
+ 
+ SELECT * FROM sample TABLESAMPLE BERNOULLI (1) REPEATABLE (19);
+ 
+ SELECT * FROM sample TABLESAMPLE SYSTEM (65) REPEATABLE (20);
+ 
+ SELECT * FROM sample TABLESAMPLE SYSTEM (65) REPEATABLE (2);
+ 
+ SELECT * FROM sample TABLESAMPLE SYSTEM (65) REPEATABLE (20);
+ 
+ SELECT * FROM sample TABLESAMPLE BERNOULLI (70) REPEATABLE (11) order by id limit 5;
+ 
+ SELECT * INTO tmp FROM sample TABLESAMPLE BERNOULLI (4);
+ 
+ DROP TABLE tmp;
+ 
+ SELECT * INTO tmp FROM sample TABLESAMPLE SYSTEM (20);
+ 
+ DROP TABLE tmp;
+ 
+ DROP TABLE sample;
